<?php

namespace Litecms\Rank;

use User;

class Rank
{
    /**
     * $rank object.
     */
    protected $rank;

    /**
     * Constructor.
     */
    public function __construct(\Litecms\Rank\Interfaces\RankRepositoryInterface $rank)
    {
        $this->rank = $rank;
    }

    /**
     * Returns count of rank.
     *
     * @param array $filter
     *
     * @return int
     */
    public function count()
    {
        return  0;
    }

    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.rank.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->rank->pushCriteria(new \Litepie\Litecms\Repositories\Criteria\RankUserCriteria());
        }

        $rank = $this->rank->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('rank::' . $view, compact('rank'))->render();
    }
}
