<?php

namespace Litecms\Rank\Repositories\Presenter;

use League\Fractal\TransformerAbstract;
use Hashids;

class RankTransformer extends TransformerAbstract
{
    public function transform(\Litecms\Rank\Models\Rank $rank)
    {
        return [
            'id'                => $rank->getRouteKey(),
            'key'               => [
                'public'    => $rank->getPublicKey(),
                'route'     => $rank->getRouteKey(),
            ], 
            'id'                => $rank->id,
            'rank_name'         => $rank->rank_name,
            'paid_referral'     => $rank->paid_referral,
            'team_investment'   => $rank->team_investment,
            'rewards'           => $rank->rewards,
            'url'               => [
                'public'    => trans_url('rank/'.$rank->getPublicKey()),
                'user'      => guard_url('rank/rank/'.$rank->getRouteKey()),
            ], 
            'status'            => trans('app.'.$rank->status),
            'created_at'        => format_date($rank->created_at),
            'updated_at'        => format_date($rank->updated_at),
        ];
    }
}